about summary refs log tree commit diff
path: root/scripts/build-chroot.sh
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/build-chroot.sh')
-rw-r--r--scripts/build-chroot.sh74
1 files changed, 74 insertions, 0 deletions
diff --git a/scripts/build-chroot.sh b/scripts/build-chroot.sh
new file mode 100644
index 0000000..a0fcf32
--- /dev/null
+++ b/scripts/build-chroot.sh
@@ -0,0 +1,74 @@
+#!/bin/sh
+set -eux
+
+CHROOT_USER=$1
+CHROOT_GROUP=$2
+
+if [ "$(uname)" = 'OpenBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc/ssl \
+		root/home \
+		root/usr/bin \
+		root/usr/lib \
+		root/usr/libexec \
+		root/usr/share/man
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /bin/sh root/bin
+	cp -fp /usr/libexec/ld.so root/usr/libexec
+	export LD_TRACE_LOADED_OBJECTS_FMT1='%p\n'
+	export LD_TRACE_LOADED_OBJECTS_FMT2=''
+	for bin in ./catgirl /usr/bin/mandoc /usr/bin/less; do
+		LD_TRACE_LOADED_OBJECTS=1 $bin | xargs -t -J % cp -fp % root/usr/lib
+	done
+	cp -fp /usr/bin/printf /usr/bin/mandoc /usr/bin/less root/usr/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /etc/ssl/cert.pem root/etc/ssl
+	cp -af /usr/share/locale /usr/share/terminfo root/usr/share
+
+	tar -c -f chroot.tar -C root bin etc home usr
+
+elif [ "$(uname)" = 'FreeBSD' ]; then
+	install -d -o root -g wheel \
+		root \
+		root/bin \
+		root/etc \
+		root/home \
+		root/lib \
+		root/libexec \
+		root/usr/bin \
+		root/usr/local/etc/ssl \
+		root/usr/share/man \
+		root/usr/share/misc
+	install -d -o ${CHROOT_USER} -g ${CHROOT_GROUP} \
+		root/home/${CHROOT_USER} \
+		root/home/${CHROOT_USER}/.local/share
+
+	cp -fp /libexec/ld-elf.so.1 root/libexec
+	ldd -f '%p\n' catgirl /usr/bin/mandoc /usr/bin/less \
+		| sort -u | xargs -t -J % cp -fp % root/lib
+	chflags noschg root/libexec/* root/lib/*
+	cp -fp /rescue/sh /usr/bin/mandoc /usr/bin/less root/bin
+	make install DESTDIR=root PREFIX=/usr MANDIR=/usr/share/man
+	install scripts/chroot-prompt.sh root/usr/bin/catgirl-prompt
+	install scripts/chroot-man.sh root/usr/bin/man
+
+	cp -fp /etc/hosts /etc/resolv.conf root/etc
+	cp -fp /usr/local/etc/ssl/cert.pem root/usr/local/etc/ssl
+	cp -af /usr/share/locale root/usr/share
+	cp -fp /usr/share/misc/termcap.db root/usr/share/misc
+
+	tar -c -f chroot.tar -C root bin etc home lib libexec usr
+
+else
+	echo "Don't know how to build chroot on $(uname)" >&2
+	exit 1
+fi
it doesn't look right unless there is only one channel listed in the status. 2019-02-22Add /znc commandJune McEnroe Only because ZNC tells you to use it and expects it to work. 2019-02-22Update status line after scrolling and term eventsJune McEnroe 2019-02-22Reorganize input.cJune McEnroe 2019-02-22Fix name of <raw> window in man pageJune McEnroe 2019-02-22Rename global tags with angle bracketsJune McEnroe 2019-02-22Show status window while connectingJune McEnroe 2019-02-22Reorganize UI code for the umpteenth timeJune McEnroe It's actually in a good state now, I think. 2019-02-21Replace "view" with "window"June McEnroe I think originally I didn't want to use the same word as curses WINDOW but it's really much clearer for the user if they're just called windows. UI code probably needs yet another rewrite though. Still feels messy. 2019-02-21Remove ROT13June McEnroe It's just not convenient when it can only do the whole line... 2019-02-21Clean up man pageJune McEnroe 2019-01-26Draw UI before connectingJune McEnroe Otherwise the "Traveling" message isn't visible while connecting. 2019-01-25Avoid unused variable warnings with getyxJune McEnroe 2019-01-25Add GNU/Linux build instructionsJune McEnroe